using System;
using System.IO;
using System.Text;
using System.Diagnostics;

namespace Streams
{
	public class StringStream : MemoryStream 
	{
		public StringStream(string text) : base() 
		{
			StreamWriter sw = new StreamWriter(this);
			sw.Write(text);
			sw.Flush();
			Position = 0;
		}

		public StringStream(string text, params object[] args) : base() 
		{
			StreamWriter sw = new StreamWriter(this);
			sw.Write(text, args);
			sw.Flush();
			Position = 0;
		}
	}

	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			MultiStream stream = new MultiStream(); 
			stream.AddStream(new StringStream("test string ")); 
			stream.AddStream(new FileStream("testfile.txt", FileMode.Open, FileAccess.Read, FileShare.Read)); 
			byte[] buf = new byte[1024]; 
			int cnt = stream.Read(buf, 0, 1024); 
			Debug.Assert(new ASCIIEncoding().GetString(buf, 0, cnt).Equals("test string test file"));
			Console.Write("Done.");
		}
	}
}
